/* FONTINST.CMD for compatibility fonts */

x = setlocal()

echo = '@'

i = 1
typ.i = CODEDFONTS;    typreq.i = NO; i = i + 1
typ.i = COMPAT240;     typreq.i = NO; i = i + 1
typ.i = COMPAT300;     typreq.i = NO; i = i + 1
typ.i = ALL;           typreq.i = NO
tottypes = i

source = '.'

ARG commandline

if WORDS(commandline) <> 0 then do
  if WORDS(commandline) < 2 then do
    targetdrv = WORD(commandline, 1)
    fontset.1 = ALL
    totfont = 1
  end
  else do
    if WORDS(commandline) < 7 then do
      targetdrv = WORD(commandline, 1)
      do i = 2 to WORDS(commandline)
        if WORDS(commandline) >= i then do
          j = i - 1
          fontset.j = WORD(commandline, i)
        end
      end
      totfont = WORDS(commandline) - 1
    end
    else do
      CALL HELP;
    end
  end
end
else do
  CALL HELP;
end

if POS(':', targetdrv) <> 2 then do
  CALL HELP;
end
drvlet = SUBSTR(targetdrv, 1, 1)
if POS(drvlet, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') = 0 then do
  CALL HELP;
end
if LENGTH(targetdrv) <> 2 then do
  CALL HELP;
end

targetdir = targetdrv || '\PSF2RES'

say '*********************************************************'
say '* Verificare che sia disponibile spazio sufficiente sul'
say '* disco fisso su cui vengono copiati i font del PSF/2.'
say '* Premere <invio> per continuare oppure <Ctl-C> per'
say '* interrompere l''installazione delle opzioni dei font'
say '* del PSF/2. Per interrompere l''installazione dopo averla'
say '* avviata,  necessario premere <Ctl-C> pi volte.'
say '*********************************************************'
parse upper pull dummy

echo || 'md 'targetdir

if rc <> 0 then do
  call RxFuncAdd 'SysMkDir', 'RexxUtil', 'SysMkDir'
  ret_code = SysMkDir(targetdir)
  if ret_code <> 5 then do
    EXIT;
  end
end

do i = 1 to totfont
  matchfound = NO
  do j = 1 by 1 while SYMBOL('typ.j') = 'VAR'
    if fontset.i = typ.j then do
      matchfound = YES
      typreq.j = YES
      leave
    end
  end
  if matchfound = NO then do
    CALL HELP;
  end
end

say '*********************************************************'
say '* Inserimento dei file dei font del PSF/2 2.00 nell''indirizzario'
say '* 'targetdir' dall''indirizzario corrente. Se esiste gi un'
say '* indirizzario, ma non esistono i file, verranno visualizzati'
say '* dei messaggi di errore. Ignorare tali messaggi. Premere'
say '* <Ctl-C> per interrompere. Pu essere necessario premere'
say '* <Ctl-C> prima che termini l''installazione.'
say '*********************************************************'

echo || 'md 'targetdir'\FONTC240'
echo || 'md 'targetdir'\FONTC300'
echo || 'md 'targetdir'\CODEFONT'
echo || 'md 'targetdir'\CODEPAGE'
echo || 'md 'targetdir'\CODEPAGE\PRIMARY'
echo || 'md 'targetdir'\CODEPAGE\SECONDRY'

echo || 'attrib -r 'targetdir'\*.* /s'
if rc <> 0 then do
  if rc <> 2 then do
    EXIT;
  end
end

font240d = NO
font300d = NO
codefontd = NO
codepaged = NO
do i = 1 to tottypes
  if typreq.i = YES then do
    select
      when typ.i = CODEDFONTS then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        codefontd = YES
      end
      when typ.i = COMPAT240 then do
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        codepaged = YES
      end
      when typ.i = COMPAT300 then do
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font300d = YES
        codepaged = YES
      end
      when typ.i = ALL then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        font300d = YES
        codefontd = YES
        codepaged = YES
      end
      otherwise
        say 'Nel programma si  verificato un errore, rivolgersi all''assistenza tecnica del PSF/2.'
    end
  end
end

targetdrv
echo || 'cd 'targetdir

say '*********************************************************'
say '* Inserimento dei font del PSF/2 2.00 nel Gestore della libreria'
say '* delle risorse. Premere <Ctl-C> per interrompere.'
say '*********************************************************'

if font240d = YES then do
  echo || 'cd .\FONTC240'
  echo || 'RLADD R *.* * /R /L > ..\FONT240.LOG'
  echo || 'cd ..'
end

if font300d = YES then do
  echo || 'cd .\FONTC300'
  echo || 'RLADD R *.* * /R /L > ..\FONT300.LOG'
  echo || 'cd ..'
end

if codefontd = YES then do
  echo || 'cd .\CODEFONT'
  echo || 'RLADD R *.* * /R /L > ..\FONTCF.LOG'
  echo || 'cd ..'
end

if codepaged = YES then do
  echo || 'cd .\CODEPAGE\PRIMARY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTPRI.LOG'
  echo || 'cd ..\SECONDRY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTSEC.LOG'
  echo || 'cd ..\..'
end

say '*********************************************************'
say '* I font sono stati inseriti, verificare i '
say '* file 'targetdir'\FONT*.LOG per i dettagli.'
say '*********************************************************'

x = endlocal()
CALL QUIT;

HELP:;
  say '**************************************************************';
  say '* Questo comando relativo all''installazione deve essere      *';
  say '* eseguito dall''indirizzario in cui sono ubicati i file      *';
  say '* per l''installazione del PSF/2.                             *';
  say '*                                                            *';
  say '* Il comando per l''installazione richiede un parametro.      *';
  say '*                                                            *';
  say '* Il formato  il seguente:                                  *';
  say '*   FONTINST <unit destinazione> <font>                     *';
  say '*                                                            *';
  say '* dove:                                                      *';
  say '*   <unit destinazione>  l''unit su cui  installato il    *';
  say '*     PSF/2 e NON l''unit su cui sono stati salvati          *';
  say '*     temporaneamente i file del PSF/2 all''utilizzo del      *';
  say '*     comando PUTDIR.                                        *';
  say '*     Questo parametro  indispensabile.                     *';
  say '*   <font> rappresenta tutte o solo una di queste opzioni:   *';
  say '*     ALL (valore assunto)                                   *';
  say '*     CODEDFONTS                                             *';
  say '*     COMPAT240                                              *';
  say '*     COMPAT300                                              *';
  say '* Esempio:                                                   *';
  say '*   fontinst c: all                                          *';
  say '*                                                            *';
  say '* I font vengono installati nell''indirizzario denominato     *';
  say '* \PSF2RES; tutti gli altri font ubicati negli indirizzari   *';
  say '* dei font vengono aggiunti al Gestore della libreria delle  *';
  say '* risorse.                                                   *';
  say '**************************************************************';
  x = endlocal()
  CALL QUIT;
RETURN;

QUIT:;
EXIT;
